<template>
    <div v-if="data">
        <Discount
            :data="data"
            @checkChanged="checkChanged"
        /> 
        <div class="discount-group edit__set_block">
            <div class="row">
                <div class="col-md-4 form-title">
                    <b>Content</b>
                </div>
                <div class="col-md-8 text-right">
                    <b-select
                        v-model="selectedTagMenu"
                        class="form-control select-tags"
                        @change="addText"
                    >
                        <option
                            v-for="(menu, index) in selectTagMenus"
                            :key="index"
                            :value="menu.title"
                            :disabled="menu.title === 'tags'"
                        >
                            {{ menu.title }}
                        </option>
                    </b-select>
                </div>
            </div>
            <ValidationProvider
                v-slot="validationContext"
                rules="required"
                :vid="data.id.toString()"
                name="Body Text"
            >
                <b-form-group class="full-width">
                    <div class="discount-text-subtitle">
                        <b>Body Text</b>
                    </div>

                    <b-form-textarea
                        v-model="data.body_text"
                        type="text"
                        class="form-control full-width my-text-area"
                        name="body_text"
                        :state="getValidationState(validationContext)"
                        @click="focus"
                        @blur="checkChanged"
                    />
                    <b-form-invalid-feedback>
                        {{ validationContext.errors[0] }}
                    </b-form-invalid-feedback>
                </b-form-group>
            </ValidationProvider>
            <ValidationProvider
                v-slot="validationContext"
                rules="required"
                :vid="data.id.toString()"
                name="Unsubscribe text"
            >
                <b-form-group class="full-width">
                    <div class="discount-text-subtitle">
                        <b>
                            Unsubscribe Text</b>
                    </div>

                    <b-form-input
                        v-model="data.unsubscribe_text"
                        class="form-control full-width"
                        :state="getValidationState(validationContext)"
                        @click="focus"
                        @blur="checkChanged"
                    />
                    <b-form-invalid-feedback>
                        {{ validationContext.errors[0] }}
                    </b-form-invalid-feedback>
                </b-form-group>
            </ValidationProvider>
            <div class="input-count-container">
                <span class="sms_counter">SMS counter: <b>{{ countOfMessages }}</b></span>
                <!-- <span>Characters left*:</span> -->
                <!-- <div style="width: 480px; margin-left: left;max-width: 100%;">
                    *Pay attention, this is an estimated number of the characters left. It&nbsp;depends on which symbols you’ll use: characters, numbers, special symbols etc.
                </div> -->
            </div>
            <validation-provider
                v-slot="validationContext"
                name="Footer"
                :rules="{ required: true }"
            >
                <b-form-group class="full-width">
                    <div class="form-content-title">
                        <b>Unsubscribe confirmation</b>
                    </div>
                    <b-form-textarea
                        v-model="data.unsubscribe_confirmation"
                        type="text"
                        class="full-width my-text-area"
                        name="Unsubscribe confirmation"
                        :state="getValidationState(validationContext)"
                        @click="focus"
                        @blur="checkChanged"
                    >
                        {{ data.unsubscribe_confirmation }}
                    </b-form-textarea>
                    <b-form-invalid-feedback>{{ validationContext.errors[0] }}</b-form-invalid-feedback>
                </b-form-group>
            </validation-provider>
        </div>
        <div class="discount-group edit__set_block">
            <div class="form-title">
                <b>Sending Timing</b>
            </div>
            <div class="discount-text-subtitle mt-4">
                Send
            </div>
            <div class="form-group form-inline">
                <b-form-input
                    id="send-time"
                    v-model="data.send_time"
                    name="send_time"
                    data-vv-as="Send Time"
                    type="number"
                    min="1"
                    class="my-input"
                    @blur="checkChanged"
                />
                <div class="select-container">
                    <b-select
                        v-model="data.send_time_type"
                        class="form-control select-tags"
                        @change="checkChanged('send_time_type')"
                    >
                        <option
                            v-for="(menu, index) in selectTagSending"
                            :key="index"
                            :value="menu.value"
                        >
                            {{ menu.title }}
                        </option>
                    </b-select>
                </div>
                <span v-if="data.order === 1">After abandonment</span>
                <span v-else>After previous reminder</span>
            </div>
        </div>
    </div>
</template>

<script>
import {tags} from "../../mixins/add-tags"
import Discount from '@/components/edit/Discount.vue'
import {SegmentedMessage} from 'sms-segments-calculator'

export default {
    name: "SmsFirstReminder",
    components: {
        Discount
    },
    mixins: [tags],
    props: ['data', 'error'],
    data: () => ({
        selectTypeMenus: [
            {
                title: 'Pre-made'
            },
            {
                title: 'Automatic'
            }
        ],
        selectTagSending: [
            {
                title: 'Minutes',
                value: 'minutes'
            },
            {
                title: 'Hours',
                value: 'hours'
            },
        ],
        selectedTagSending: 'Minutes',
        selectTagMenus: [
            {
                title: 'tags'
            },
            {
                title: ' {domain}'
            },
            {
                title: ' {firstName}'
            },
            {
                title: ' {lastName}'
            },
            {
                title: ' {siteName}'
            },
            {
                title: ' {cartLink}'
            },
            {
                title: ' {discountValue}'
            },
            {
                title: ' {discountCode}'
            },
            {
                title: ' {storeEmail}'
            },

        ],
        selectedTagMenu: 'tags',
        selectedTypeMenu: 'Pre-made',
        focusedInput: 0,
        focusedName: '',
        characterLimit: '',
        maxCharacter: 133,
    }),
     computed: {
        countOfMessages(){
            const INDENT_BETWEEN_BLOCKS_AND_UNSUBSCRIBE_LINK_LENGTH = '0123456789123456'
            return  new SegmentedMessage(this.data.body_text + this.data.unsubscribe_text + INDENT_BETWEEN_BLOCKS_AND_UNSUBSCRIBE_LINK_LENGTH).segmentsCount 
        }
    },
    methods: {
        addText() {
            if(this.focusedName) {
                const data = this.addTag(this.data, this.focusedName, this.focusedInput, this.selectedTagMenu)

                if(data.keys.length > 1) this.data[data.keys[0]][data.keys[1]] = data.value
                else this.data[data.keys[0]] = data.value
            
            this.focusedInput += this.selectedTagMenu.length
            }
            this.selectedTagMenu = 'tags'
        },
        checkChanged(key) {
            if(key) this.$emit('checkChanged', key)
            
        },
        focus(e) {
            this.focusedInput = e.target.selectionStart
            this.focusedName = e.target.name
        },
        getValidationState({dirty, validated, valid = null}) {
            return dirty || validated ? valid : null;
        },
    }
}
</script>

<style scoped lang="scss">
.input-count-container{
    text-align: right;
}
.form-inline {
    display: flex !important;
}


.select-tags {
    background-color: white;
}

.my-input {
    max-width: 100px;
}

.my-select-menu {
    max-width: 100px;
}

</style>

